from Foundation import NSObject
from AppKit import NSApplication, NSURLRequest, NSURL
from WebKit import WebView, protocols
from objc import nil, YES, NO

class AppDelegate(NSObject):
    url = None
    
    def applicationDidFinishLaunching_(self, aNotification):
        self.webView = WebView.alloc().initWithFrame_(((0, 0), (1, 1)))
        
        self.loadDelegate = LoadDelegate.alloc().init()
        self.webView.setFrameLoadDelegate_(self.loadDelegate)

        request = NSURLRequest.requestWithURL_(NSURL.URLWithString_(self.url))
        self.webView.mainFrame().loadRequest_(request)
                
class LoadDelegate(NSObject, protocols.WebFrameLoadDelegate):
    def webView_didFinishLoadForFrame_(self, webView, frame):
        if not frame.parentFrame():
            self.mainFrame = frame;
            frame.windowObject().evaluateWebScript_('require.ready(function(){appjs.ready()})')

    def webView_didClearWindowObject_forFrame_(self, webView, window, frame):
        if not frame.parentFrame():
            window.setValue_forKey_(self, "appjs")

    def isKeyExcludedFromWebScript_(self, key):
        return YES

    def isSelectorExcludedFromWebScript_(self, sel):
        return NO if str(sel) in ["ready"] else YES

    def ready(self):
        print self.mainFrame.windowObject().evaluateWebScript_('require.generate()')
        NSApplication.sharedApplication().terminate_(nil)
            
def generateStylesheets(url):
    delegate = AppDelegate.alloc().init()
    delegate.url = url

    app = NSApplication.sharedApplication()
    app.setDelegate_(delegate)
    app.run()    

def main():
    import sys
    if len(sys.argv) > 1:
        generateStylesheets(sys.argv[1])    

if __name__ == '__main__':
    main()
